package models

import (
	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/mongo"
	ct "gogs.mikescher.com/BlackForestBytes/goext/cursortoken"
)

type SubscriptionFilter struct {
	UserID         *AppUserID
	OrganizationID *OrganizationID
	GroupID        *GroupID
}

func (f SubscriptionFilter) FilterQuery() mongo.Pipeline {
	pipeline := mongo.Pipeline{}

	pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"deleted": nil}}})

	if f.UserID != nil {
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"userID": *f.UserID}}})
	}

	if f.OrganizationID != nil {
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"organizationID": *f.OrganizationID}}})
	}

	if f.GroupID != nil {
		pipeline = append(pipeline, bson.D{{Key: "$match", Value: bson.M{"groupID": *f.GroupID}}})
	}

	return pipeline
}

func (f SubscriptionFilter) Pagination() (string, ct.SortDirection, string, ct.SortDirection) {
	return "creationTime", ct.SortDESC, "_id", ct.SortDESC
}
